
      PROGRAM TZHEGV31
*
*       ணࠬ   PZHEGV3
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, LRWORK,
     $                   LIWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 100, LWORK = 5577, MAXN = 100,
*      PARAMETER          ( LDA = 100, LWORK = -1, MAXN = 100,
*     $                   LRWORK = -1, LIWORK = -1,
     $                   LRWORK = 45, LIWORK = 30,
     $                   MAXPROCS = 512, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*
*  ६ ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB, M,
     $                   IFAIL, NPCOL, NPROCS, NPROW, IA, JA, IB, JB,
     $                   IBTYPE
      DOUBLE PRECISION   ABSTOL, VL, VU
*
*  ᨢ ..
      INTEGER            DESCA( 9 ), DESCB( 9 ),
     $                   IWORK( LIWORK )
*     $                   IWORK( 30 )
      DOUBLE PRECISION   W( MAXN ), RWORK( LRWORK )
*      DOUBLE PRECISION   RWORK( 45 ), W( MAXN )
*
      DOUBLE COMPLEX     A( LDA, LDA ), B( LDA, LDA ), WORK1( 5 ),
     $                   WORK( LWORK )
*     $                   WORK( 150 )
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PZLAPRNT,
     $                   PZHEGV3
*
* 믮塞  ..
*
* ⠭ 
*
      N = 5
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      VL = 0.0D0
      VU = 1.0D0
      IBTYPE = 1
      ABSTOL = 0.D0
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
* 樠 ਯ஢    A  B
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
      CALL DESCINIT( DESCB, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* ஥   A  B
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO, IBTYPE, ABSTOL
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A, ' IBTYPE =',I3, '   ABSTOL =', D10.2 /)
*
      CALL PZLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  B'
      END IF
      CALL PZLAPRNT( N, N, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1 )
*
* 襭 饭 ஡ ᮡ⢥ 祭
*
      CALL PZHEGV3( IBTYPE, UPLO, N, A, IA, JA, DESCA,
     $              B, IB, JB, DESCB, VL, VU, ABSTOL, M, W, WORK,
     $              LWORK, RWORK, LRWORK, IWORK, LIWORK, IFAIL, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
*         WRITE( NOUT, FMT = 9986 )WORK(1), RWORK(1), IWORK(1)
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
      END IF
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PZHEGV3' )
 9998 FORMAT( / ' ᫥ ᮡ⢥ 祭 ',
     $      '  饭 ஡ ᮡ⢥ 祭 '/
     $       '  ࢠ ( VL, VU )',
     $      '    A  B,'/
     $      '  A  B -  ନ⮢  ',
     $      I2, '  ', I2,',' ,
     $       '      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
* 9986 FORMAT( /' WORK(1) =', D14.5, D14.5, ' RWORK(1) =', D12.3,
*     $        ' IWORK(1) =' I3 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।   A  B   ⪥ ᮢ
*
*  ⠭ - ࠬ ..
      INTEGER         DLEN_, CTXT_
      PARAMETER       ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE COMPLEX  ONE
      PARAMETER       ( ONE = (1.0D+0, 0.0D0) )
      INTEGER         IA, INFO, JA, N
      INTEGER         DESCA( * ), DESCB( * )
      DOUBLE COMPLEX  A( * ), B( * )
      INTEGER         I, J, MYCOL, MYROW, NPCOL, NPROW
      EXTERNAL        PZELSET
      INTRINSIC       DBLE
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PZELSET( A, I, J, DESCA, (0.0D0, 0.0D0) )
      CALL PZELSET( B, I, J, DESCB, (0.0D0, 0.0D0) )
    1 CONTINUE
    2 CONTINUE
      DO 3 I = 1, N-1
         J = I+1
         CALL PZELSET( A, I, J, DESCA, ONE)
         CALL PZELSET( B, I, J, DESCB, ONE)
    3 CONTINUE
      J = N
      DO 5 I = 1, N-1
      CALL PZELSET( A, I, J, DESCA, ONE )
      CALL PZELSET( B, I, J, DESCB, ONE )
    5 CONTINUE
*
      CALL PZELSET( A, 1, 1, DESCA, (10.0D0, 0.0D0) )
      CALL PZELSET( A, 1, 2, DESCA, (2.0D0, 0.0D0) )
      CALL PZELSET( A, 1, 3, DESCA, (3.0D0, 0.0D0) )
      CALL PZELSET( A, 1, 4, DESCA, ONE)
      CALL PZELSET( A, 2, 2, DESCA, (12.0D0, 0.0D0) )
      CALL PZELSET( A, 2, 4, DESCA, (2.0D0, 0.0D0) )
      CALL PZELSET( A, 3, 3, DESCA, (11.0D0, 0.0D0) )
      CALL PZELSET( A, 3, 5, DESCA, -ONE)
      CALL PZELSET( A, 4, 4, DESCA, (9.0D0, 0.0D0) )
      CALL PZELSET( A, 5, 5, DESCA, (15.0D0, 0.0D0) )
*
      CALL PZELSET( B, 1, 1, DESCB, (12.0D0, 0.0D0) )
      CALL PZELSET( B, 1, 3, DESCB, -ONE)
      CALL PZELSET( B, 1, 4, DESCB, (2.0D0, 0.0D0) )
      CALL PZELSET( B, 2, 2, DESCB, (14.0D0, 0.0D0) )
      CALL PZELSET( B, 2, 4, DESCB, -ONE)
      CALL PZELSET( B, 3, 3, DESCB, (16.0D0, 0.0D0) )
      CALL PZELSET( B, 3, 4, DESCB, -ONE)
      CALL PZELSET( B, 4, 4, DESCB, (12.0D0, 0.0D0) )
      CALL PZELSET( B, 4, 5, DESCB, -ONE)
      CALL PZELSET( B, 5, 5, DESCB, (11.0D0, 0.0D0) )
*
      RETURN
*
*     End of PDMATINIT
*
      END
